/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


#include "maxfdefine.h"
#include <os2.h>
#include <sys/winmgr.h>
#include <stdlib.h>
#include "maxfstruct.h"

extern int MaxX;
extern int MaxY;
extern int MidX;
extern int MidY;

#define FileHelp 1
#define DescHelp 2
#define SortHelp 3
#define MainHelp 4
#define EditHelp 5
#define AreaHelp 6
#define DupeHelp 7
#define SearchHelp 8
#define Ok2OperateHelp 9



void HELP(int type)
{
  wm_handle Help;
  int L;
  int mid;

  L = MidX - 39;
  mid = MidX+1;
  switch (type){
  case FileHelp:
    Help = wm_create(MidX-30, MidY-11, MidX+30, MidY+11, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "File Menu Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);

    wm_puts_at(Help,0,1,"The options C, V, R, D, P, T, N, will affect all marked");
    wm_puts_at(Help,0,2,"entries or only the present selected one if none are marked");

    wm_puts_at(Help,0,4, "M:     Move the selected files to another area");
    wm_puts_at(Help,0,5, "C:     Display contents of an archive");
    wm_puts_at(Help,0,6, "V:     Verify integrity of an archive");
    wm_puts_at(Help,0,7, "R:     Change the archive type of a file");
    wm_puts_at(Help,0,8, "A:     Adopt orphans in the present directory");
    wm_puts_at(Help,0,9, "D:     Delete the file and remove files.bbs entry");
    wm_puts_at(Help,0,10, "W:     View a Gif/JPG/BMP/TIF/PCX/TXT file");
    wm_puts_at(Help,0,11,"T:     Touch a file (Set file date to now)");
    wm_puts_at(Help,0,12,"N:     Scan an archive for Virii");
    wm_puts_at(Help,0,13,"K:     Mark all files for operation");
    wm_puts_at(Help,0,14,"U:     Unmark all files");
    wm_puts_at(Help,0,15,"S:     Save the current state of the files.bbs");
    wm_puts_at(Help,0,16,"I:     Insert a new file or comments");
    wm_puts_at(Help,0,17,"O:     Reposition the selected files");
    wm_puts_at(Help,0,18,"H:     Search for dupes");
    wm_puts_at(Help,0,19,"L:     Locate a string in any of the files.bbses");
    wm_puts_at(Help,0,20,"E:     Rename all marked files");
    wm_puts_at(Help,0,21,"X:     Exit MaxFile/2");


    break;
  case SortHelp:
    Help = wm_create(MidX-25, MidY-3, MidX+25, MidY+4, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Sort Menu Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);
    wm_puts_at(Help,0,1, "N:     Sort files by name (increasing)");
    wm_puts_at(Help,0,2, "D:     Sort files by date (increasing)");
    wm_puts_at(Help,0,3, "S:     Sort files by Size (increasing)");
    wm_puts_at(Help,0,4, "n:     Sort files by name (decreasing)");
    wm_puts_at(Help,0,5, "d:     Sort files by date (decreasing)");
    wm_puts_at(Help,0,6, "s:     Sort files by Size (decreasing)");

    break;
  case Ok2OperateHelp:
    Help = wm_create(MidX-31, MidY-4, MidX+31, MidY+4, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "File Operation Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);

    wm_puts_at(Help,0,1, "You have selected the listed files for an operation.");
    wm_puts_at(Help,0,2, "This window gives you the oportunity to modify the");
    wm_puts_at(Help,0,3, "list of selected files.  Press");

    wm_puts_at(Help,0,5, "SPACE  to remove a file from the list");
    wm_puts_at(Help,0,6, "ESC    to abort the operation and retain the original list");
    wm_puts_at(Help,0,7, "RETURN to accept the current list");


    break;
  case DupeHelp:
    Help = wm_create(MidX-28, MidY-7, MidX+28, MidY+7, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Duplicate Search Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);
    wm_puts_at(Help,0,1, "z:         Toggles display of the file size");
    wm_puts_at(Help,0,2, "t:         Toggles the display of the date");
    wm_puts_at(Help,0,3, "w:         Toggles the wrapping of the descriptions");
    wm_puts_at(Help,0,4, "v:         Verifies the highlighted file");
    wm_puts_at(Help,0,5, "<alt-v>:   Verifies the selected file(s)");
    wm_puts_at(Help,0,6, "c:         Shows the contents of the highlighted file");
    wm_puts_at(Help,0,7, "<ALT-C>:   Shows the contents of the selected file(s)");
    wm_puts_at(Help,0,8, "e:         Edit the highlighteded description");
    wm_puts_at(Help,0,6, "<ALT-E>    Edit the selected description(s)");
    wm_puts_at(Help,0,10, "SPACE:     (de)selects the present file.");
    wm_puts_at(Help,0,11, "d,<ALT_D>: Deletes the selected files");
    wm_puts_at(Help,0,12, "r,<ALT-R>: Removes the selected descriptions");
    wm_puts_at(Help,0,13, "<esc>:     Exit dupe search mode");

    break;
  case SearchHelp:
    Help = wm_create(MidX-28, MidY-4, MidX+28, MidY+4, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Locate Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);
    wm_puts_at(Help,0,1, "a:         Aborts the present search");
    wm_puts_at(Help,0,2, "<esc>      Ignores present file and continues");
    wm_puts_at(Help,0,3, "d,<ALT-D>: Deletes the selected file");
    wm_puts_at(Help,0,4, "c,<ALT-C>: Shows the contents of the selected file");
    wm_puts_at(Help,0,5, "e:         Edit the selected description");
    wm_puts_at(Help,0,6, "r,<ALT-R>: Remove the description");
    wm_puts_at(Help,0,7, "m:         Move the located file to another area");

    break;
  case DescHelp:
    Help = wm_create(MidX-36, MidY-4, MidX+36, MidY+4, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Description Menu Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_open(Help);
    wm_puts_at(Help,0,1,"The below options will affect all marked entries or");
    wm_puts_at(Help,0,2,"only the present selected one if none are marked");
    wm_puts_at(Help,0,4, "R:     remove files.bbs entry");
    wm_puts_at(Help,0,5, "E:     Edit the files.bbs entry");
    wm_puts_at(Help,0,6, "N:     enter a new files.bbs entry");
    wm_puts_at(Help,0,7, "U:     Extract File_id.diz/DESC.SDI and use as file desription");
    wm_puts_at(Help,0,8, "I:     Insert a comment before the current line");

    break;
  case AreaHelp:
    Help = wm_create(MidX-25, MidY-4, MidX+25, MidY+4, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Area Seletion Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_puts_at(Help,0,1,"You can select an area for the selected operation.");
    wm_puts_at(Help,0,2,"Pressing up, down, pageup, pagedown, home or end");
    wm_puts_at(Help,0,3,"scroll through the selections.  Entering a number");
    wm_puts_at(Help,0,4,"will take you to that area");
    wm_puts_at(Help,0,5,"If you area searching for duplicates, pressing");
    wm_puts_at(Help,0,6,"the space bar will select the area(s) in which to");
    wm_puts_at(Help,0,7,"check for duplicate files.  Pressing <F10>");
    wm_puts_at(Help,0,8,"selects/deselects all areas");

    wm_open(Help);
    break;
  case EditHelp:
    Help = wm_create(MidX-25, MidY-2, MidX+25, MidY+2, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Editor Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_puts_at(Help,0,1,"Press F10 to accept");
    wm_puts_at(Help,0,2,"Press arrow keys to move");
    wm_puts_at(Help,0,3,"Press Home/End to move to begining/end of desc");
    wm_puts_at(Help,0,4,"ENTER is interpreted as a space");

    wm_open(Help);
    break;
  case MainHelp:
    Help = wm_create(L, MidY-10, MidX+39, MidY+10, 2,
		     F_WHITE|B_BLACK|INTENSITY,F_WHITE|B_BLACK|INTENSITY);
    wm_open(Help);
    wm_border(Help, 2, F_YELLOW|B_BLACK|INTENSITY,
	      "Main Help.  Press any key to continue",
	      1,F_RED|B_WHITE|INTENSITY);
    wm_puts_at(Help,0,1, "R:           read files.bbs from disk  |");
    wm_puts_at(Help,0,2, "A:           change file area          |");
    wm_puts_at(Help,0,3, "K:           marK all                  |");
    wm_puts_at(Help,0,4, "U:           Unmark all                |");
    wm_puts_at(Help,0,5, "W, Z, D:     toggle Wrap, siZe and Date|");
    wm_puts_at(Help,0,6, "M:           move file(s)              |");
    wm_puts_at(Help,0,7, "S:           Save current files.bbs    |");
    wm_puts_at(Help,0,8, "[, ]:        go to previous, next area |");
    wm_puts_at(Help,0,9, "TAB:         switch between windows    |");
    wm_puts_at(Help,0,10,"Up, Down:    scroll file list up, Down |");
    wm_puts_at(Help,0,11,"Right, Left: grow window rt, left      |");
    wm_puts_at(Help,0,12,"ctrl Right:  shrink rt side of window  |");
    wm_puts_at(Help,0,13,"ctrl Left:   shrink left side of window|");
    wm_puts_at(Help,0,14,"ctrl PGUP:   Maximize window           |");
    wm_puts_at(Help,0,15,"HOME, END:   go to top, end of list    |");
    wm_puts_at(Help,0,16,"pgup,pgdown: file list up, down 1 page |");
    wm_puts_at(Help,0,17,"space:       select/deselect a file    |");
    wm_puts_at(Help,0,18,"<alt-F>:     open file menu            |");
    wm_puts_at(Help,0,19,"<alt-D>:     open description menu     |");
    wm_puts_at(Help,0,20,"<alt-S>:     open Sort menu            |");
    wm_puts_at(Help,mid,1, "<alt-X>:     exit");
    wm_puts_at(Help,mid,2, "<alt-E>:     Edit file description(s)");
    wm_puts_at(Help,mid,3, "<alt-R>:     remove (delete) file(s)");
    wm_puts_at(Help,mid,4, "<alt-N>:     Scan file(s) for virii");
    wm_puts_at(Help,mid,5, "<alt-P>:     View picture files");
    wm_puts_at(Help,mid,6, "<alt-A>:     Adopt orphans");
    wm_puts_at(Help,mid,7, "<alt-C>:     Contents of archive(s)");
    wm_puts_at(Help,mid,8, "<alt-V>:     Verify archive(s)");
    wm_puts_at(Help,mid,9, "<alt-I>:     use file_Id.diz");
    wm_puts_at(Help,mid,10, "<alt-O>:     Reposition files");
    wm_puts_at(Help,mid,11,"<alt-UP>:    Grow top of window");
    wm_puts_at(Help,mid,12,"<alt-DOWN>:  Grow bottom of window");
    wm_puts_at(Help,mid,13,"<ctrl-UP>:   Shrink top of window");
    wm_puts_at(Help,mid,14,"<ctrl-DOWN>: Shrink bottom of window");
    wm_puts_at(Help,mid,15,"<ctrl-PgUp>: Maximize Window");
    wm_puts_at(Help,mid,16,"<ctrl-PgDn>: Size window to 1/2 screen");
    wm_puts_at(Help,mid,17,"<F2>-<F9>:   Execute macro 2 through 9");
    wm_puts_at(Help,mid,19,"<alt-Z>:     ABOUT MaxFile/2");

    break;
  }
  if (!_read_kbd(0,1,0)) _read_kbd(0,1,0);
  wm_close(Help);
  wm_delete(Help);
}


