/*
*    Copyright (C) 1995 Ronald Van Iwaarden
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    I can presently be contacted on the internet at
*
*    rvaniwaa@carbon.denver.colorado.edu
*    rvaniwaa@smaug.cs.hope.edu
*   
*    or by snail mail at:
*
*    Ronald Van Iwaarden
*    4351 60th St.
*    Holland MI, USA, 49423
*/


#include "maxfdefine.h"
#include <ctype.h>
#include <io.h>
#include <stdlib.h>
#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/winmgr.h>
#include <strings.h>
#include <sys/video.h>

#include "maxstruc.h"
#include "error.h"
#include "maxfstruct.h"
#include "mem.h"
#include "utils.h"
#include "read_areas.h"


void free_window(struct Window *);
extern struct Window windowlist[maxwindows];
extern int cstart, cend, xpos, ypos;
extern int numareas;
extern struct FileArea * fileareas;

char LongestAreaName = 0;



void bad_exit(void * adat)
{
  error2("Was not able to open",(PCH) adat);
  wm_close_all();
  free_mem();
  free_window(&windowlist[1]);
  free_window(&windowlist[2]);
  v_gotoxy(xpos, ypos);
  v_ctype(cstart, cend);
  exit(-1);
}


void ReadSBBSDat(void *adat)
{
  FILE *f;
  SBBSINFO a;
  int i = 0;
  char *strptr;
  char junk[10];

  f = fopen((PCH) adat, "rb");
  if (f != NULL)
    {
      fseek(f, 0L, SEEK_SET);	/* rewind input file */
      while (fread(&a, sizeof(SBBSINFO), 1, f)) /* read til done */
        ++numareas;
      fileareas = (struct FileArea *)
	mem_realloc(fileareas, (numareas+1)* sizeof(struct FileArea));

      fseek(f, 0L, SEEK_SET);	/* rewind input file */
      while (fread(&a, sizeof(SBBSINFO), 1, f)) /* read til done */
	{
	  strcpy(fileareas[i].Area, _ltoa(i, junk, 10));
	  strcpy(fileareas[i].FileInfo, a.fileinfo);
	  strcpy(fileareas[i].Download, a.filepath);
	  if (fileareas[i].Download[strlen(fileareas[i].Download)-1]=='\\')
	    fileareas[i].Download[strlen(fileareas[i].Download)-1]=0;
	  make_full_path(fileareas[i].Download);
	  if (a.filesbbs[0] == '*'){
	    strptr = &a.filesbbs[1];
	    strcpy(fileareas[i].Upload, strptr);}
	  else strcpy(fileareas[i].FileList, a.filesbbs);
	  make_full_path(fileareas[i].FileList);
	  fileareas[i].backed_up = 0;
	  ++i;
	}
      fclose(f);
    }
  else bad_exit(adat);
}


void ReadGDat(void *ADAT)
{
  FILE *f;
  CHAR text[300];
  PSZ p;
  GENAREAS ga;
  ULONG i;
  PCH adat = (PCH) ADAT;

  numareas = 0;
  f = fopen(adat, "r");
  if (f)
    {
      while (fgets(text, 300, f)!= NULL)
        {
	  p = text;
	  while ((isspace(*p)) && (*p)) p++;
	
	  if (!strnicmp(p, "AREACOUNT", 9))
            {
	      p += 9;
	      while ((isspace(*p)) && (*p)) p++;
	      numareas = atol(p);
	      break;
            }
        }
      fileareas = (struct FileArea *)
	mem_realloc(fileareas, (numareas+1)* sizeof(struct FileArea));
      if (numareas)
        {
	
	  i = 0;
	
	  while ((fgets(text, 300, f)!= NULL) && (i < numareas))
	    {
	      p = text;
	      while (*p >= '\x20') p++;
	      *p = '\0';
	
	      p = text;
	      if (*p)
		{
		  while ((isspace(*p)) && (*p)) p++;
		  strncpy(ga.n, p, 40);

		  while ((!isspace(*p)) && (*p)) p++;
		  while ((isspace(*p)) && (*p)) p++;
		  strncpy(ga.filepath, p, CCHMAXPATH);
		
		  while ((!isspace(*p)) && (*p)) p++;
		  while ((isspace(*p)) && (*p)) p++;
		  strncpy(ga.filesbbs, p, CCHMAXPATH);
		
		  while ((!isspace(*p)) && (*p)) p++;
		  while ((isspace(*p)) && (*p)) p++;
		  strncpy(ga.fileinfo, p, 80);
		
		  p = ga.n;
		  while ((!isspace(*p)) && (*p)) p++;
		  *p = '\0';
		
		  p = ga.filepath;
		  while ((!isspace(*p)) && (*p)) p++;
		  *p = '\0';
		
		  p = ga.filesbbs;
		  while ((!isspace(*p)) && (*p)) p++;
		  *p = '\0';

		  strcpy(fileareas[i].Area, ga.n);
		  strcpy(fileareas[i].FileInfo, ga.fileinfo);
		  if (ga.filepath[strlen(ga.filepath) -1] == '\\')
		    ga.filepath[strlen(ga.filepath) -1] = 0;
		  strcpy(fileareas[i].Download, ga.filepath);
		  strcpy(fileareas[i].FileList, ga.filesbbs);
		  fileareas[i].backed_up = 0;

		  i++;
		}
	    }
	}
      fclose(f);
    }
  else bad_exit(ADAT);
}



void ReadSDat(void *adat)
{
  FILE *f;
  LORASYS a;
  int i = 0;

  f = fopen((PCH) adat, "rb");
  if (f != NULL)
    {
      fseek(f, 0L, SEEK_SET);	/* rewind input file */
      while (fread(&a, sizeof(LORASYS), 1, f)) /* read til done */
        ++numareas;
      fileareas = (struct FileArea *)
	mem_realloc(fileareas, (numareas+1)* sizeof(struct FileArea));

      fseek(f, 0L, SEEK_SET);	/* rewind input file */
      while (fread(&a, sizeof(LORASYS), 1, f)) /* read til done */
	{
	  _ltoa(a.file_num, fileareas[i].Area, 10);
	  strcpy(fileareas[i].FileInfo, a.fileinfo);
	  strcpy(fileareas[i].Download, a.filepath);
	  if (fileareas[i].Download[strlen(fileareas[i].Download)-1]=='\\')
	    fileareas[i].Download[strlen(fileareas[i].Download)-1]=0;
	  make_full_path(fileareas[i].Download);
	  strcpy(fileareas[i].Upload, a.uppath);
	  strcpy(fileareas[i].FileList, a.filesbbs);
	  make_full_path(fileareas[i].FileList);
	  fileareas[i].backed_up = 0;
	  ++i;
	}
      fclose(f);
    }
  else bad_exit(adat);
}



void FindAreas(void *adat)
{
  FILE *f;
  struct _area a;
  ULONG asize;
  INT x = 0;
  int i = 0;

  f = fopen((PCH) adat, "rb");
  if (f != NULL)
    {
      if (fread(&a, sizeof(struct _area), 1, f)) /* read first record */
	{
	  asize = a.struct_len;
	  fseek(f, 0L, SEEK_SET);	/* rewind input file */
	  while (fread(&a, sizeof(struct _area), 1, f)) /* read til done */
	    {
	      if (strlen(a.filepath)) ++numareas;
	      fseek(f, asize*(++x), SEEK_SET);
	    }
	  x = 0;
	  fileareas = (struct FileArea *)
	    mem_realloc(fileareas, (numareas+1)* sizeof(struct FileArea));

	  fseek(f, 0L, SEEK_SET);	/* rewind input file */
	  while (fread(&a, sizeof(struct _area), 1, f)) /* read til done */
	    {
	      if (strlen(a.filepath))
		{
		  strcpy(fileareas[i].Area, a.name);
		  strcpy(fileareas[i].FileInfo, a.fileinfo);
		  strcpy(fileareas[i].Download, a.filepath);
		  fileareas[i].Download[strlen(fileareas[i].Download)-1]=0;
		  strcpy(fileareas[i].Upload, a.uppath);
		  strcpy(fileareas[i].FileList, a.filesbbs);
		  fileareas[i].backed_up = 0;
		  ++i;
		}
	      fseek(f, asize*(++x), SEEK_SET);
	    }
	}
      fclose(f);
    }
  else bad_exit(adat);
}



int CompareAreas(struct FileArea * a1, struct FileArea* a2)
{
  char area1[80];
  char area2[80];
  int i;

  strcpy(area1, "");
  strcpy(area2, "");
  for (i=0; i < LongestAreaName - strlen(a1->Area); ++i) strcat(area1, " ");
  for (i=0; i < LongestAreaName - strlen(a2->Area); ++i) strcat(area2, " ");
  strcat(area1, a1->Area);
  strcat(area2, a2->Area);
  return stricmp(area1, area2);
}

void SortAreas()
{
  int i;
  char temp;

  for (i=0; i < numareas; ++i)
    {
      temp = strlen(fileareas[i].Area);
      if (temp > LongestAreaName) LongestAreaName = temp;
    }
  qsort(fileareas, numareas, sizeof(struct FileArea), (void *)CompareAreas);
}
